/*******************
 *
 * Copyright 1998 IAR Systems. All rights reserved.
 *
 * $Revision: 1.3 $
 *
 * $Log: callnewh.cpp $
 * Revision 1.3  2004/04/26 13:36:31Z  mats
 * Removed remarks and fixed prototypes
 * Revision 1.2  1998/10/02 08:44:21Z  AndersL
 *
 ********************/

#include <stddef.h>

/* Can't include "new" since it's a C++ file. */
typedef void (*new_handler)(void);

/* Defined in New.cpp */

extern new_handler _New_hand;

/*
 * Return non-zero if the new-handler managed to add more
 * memory to the free pool.
 *
 * Note that it is guaranteed that if it ever returns it has done
 * this, hence we can return non-nil if we have a new-handler and
 * it returned.
 */

#pragma diag_suppress = Pe826

int (_callnewh)(size_t size)
{
  if (_New_hand)
    {
      (*_New_hand)();
      return 1;
    }
  return 0;
}
