/* getchar function */
#include "xstdio.h"

_STD_BEGIN

#if _DLIB_FILE_DESCRIPTOR

int (getchar)(void)
{	/* get a character from stdin */
  return (fgetc(stdin));
}

int __ungetchar(int c)
{       /* Unget a character from stdin */
  return ungetc(c, stdin);
}

#else /* _DLIB_FILE_DESCRIPTOR */

#include <yfuns.h>

/* The char which has been ungotten, or EOF. */
static int _UngetChar = EOF;

int (getchar)(void)
{	/* get a character from stdin */
  if (_UngetChar != EOF)
  {
    int res = _UngetChar;
    _UngetChar = EOF;
    return res;
  }
  else
  {
    unsigned char buf[1];
    if (__read(_LLIO_STDIN, buf, 1) == 1)
    {
      return buf[0];
    }
    else
    {
      return EOF;
    }
  }
}


int __ungetchar(int c)
{       /* Unget a character from stdin */
  _UngetChar = c;
  return c;
}


#endif /* _DLIB_FILE_DESCRIPTOR */

_STD_END

/*
 * Copyright (c) 1992-2002 by P.J. Plauger.  ALL RIGHTS RESERVED.
 * Consult your license regarding permissions and restrictions.
V3.12:0576 */
