/* getwchar function */
/* Copyright (C) 2003 IAR Systems.   All rights reserved. */

#include "xwstdio.h"
#include <yfuns.h>

_STD_BEGIN

#if _DLIB_FILE_DESCRIPTOR

wint_t (getwchar)(void)
	{	/* get a wchar_t from wide stdin */
	return (fgetwc(stdin));
	}

wint_t __ungetwchar(wint_t c)
{       /* Unget a character from stdin */
  return ungetwc(c, stdin);
}

#else

/* The char which has been ungotten, or EOF. */
static wint_t _UngetWChar = WEOF;

wint_t (getwchar)(void)
{	/* get a wchar_t from wide stdin */
  if (_UngetWChar != WEOF)
  {
    wint_t res = _UngetWChar;
    _UngetWChar = WEOF;
    return res;
  }
  else
  {
    unsigned char buf[1];
    struct _Mbstatet state = {0};
    wchar_t wc;
    int count = 0;

    for (;;)
    {
      if (__read(_LLIO_STDIN, buf, 1) == 1)
      {
        ++count;

        switch (_Mbtowc(&wc, (const char *)buf, 1, &state))
        {
        case -2: /* Not done yet */
          if (count > MB_LEN_MAX)
          {
            return WEOF;
          }
          /* Continue read more characters. */
          break;

        case -1: /* Bad multibyte character */
          return WEOF;

        default:
          return wc;
        }
      }
      else
      {
        return WEOF;
      }
    }
  }
}

wint_t __ungetwchar(wint_t c)
{       /* Unget a wide character from stdin */
  _UngetWChar = c;
  return c;
}

#endif /* _DLIB_FILE_DESCRIPTOR */

_STD_END
