// iostream -- ios::Init members, initialize standard streams
#include <yvals.h>

#if _DLIB_FILE_DESCRIPTOR

#include <fstream>

#else

#include <xxnofilebuf>

#endif

#include <istream>	/* NOT <iostream>, don't want Init object constructed */
#include <new>
_STD_BEGIN

		// OBJECT DECLARATIONS
int ios_base::Init::_Init_cnt = -1;	// net constructors - destructors

#if _DLIB_FILE_DESCRIPTOR
static filebuf fin(_Noinit);	// uninitialized cin buffer
static filebuf fout(_Noinit);	// uninitialized cout buffer
#else
static __nofilebuf fin(_Noinit);	// uninitialized cin buffer
static __nofilebuf fout(_Noinit);	// uninitialized cout buffer
#endif

istream cin(_Noinit);	// uninitialized cin
ostream cout(_Noinit);	// uninitialized cout


ios_base::Init::Init()
	{	// initialize standard streams first time
	bool doinit;
		{	// lock and test whether to initialize
		_Lockit lock(_LOCK_STREAM);
		if (0 <= _Init_cnt)
			++_Init_cnt, doinit = false;	// redundant initialization, skip
		else
			_Init_cnt = 1, doinit = true;	// first initialization, do it
		}

	if (doinit)
		{	// initialize standard streams
#if _DLIB_FILE_DESCRIPTOR
		new (&fin) filebuf(stdin);
		new (&fout) filebuf(stdout);
#else
		new (&fin) __nofilebuf();
		new (&fout) __nofilebuf();
#endif
		new (&cin) istream(&fin, true);
		new (&cout) ostream(&fout, true);
		cin.tie(&cout);
		}
	}

ios_base::Init::~Init()
	{	// flush standard streams on last destruction
	bool doflush;
		{	// lock and test whether to flush streams
		_Lockit lock(_LOCK_STREAM);
		if (--_Init_cnt == 0)
			doflush = true;	// last destruction, do it
		else
			doflush = false;	// not last destruction, skip
		}

	if (doflush)
		{	// flush standard streams, but don't destroy
		cout.flush();
		}
	}
_STD_END

char _PJP_CPP_Copyright[] =
	"Copyright (c) 1992-2002 by P.J. Plauger,"
	" licensed by Dinkumware, Ltd."
	" ALL RIGHTS RESERVED.";

/*
 * Copyright (c) 1992-2002 by P.J. Plauger.  ALL RIGHTS RESERVED.
 * Consult your license regarding permissions and restrictions.
V3.12:0576 */
