/* mktime function */
#include <limits.h>
#include "xtime.h"
_STD_BEGIN

time_t (mktime)(struct tm *t)
{	/* convert local time structure to scalar time */
#if 0
        /* Se change below */
	double dsecs;
#else
        long cdays, csecs;
#endif
	int mon, year, ymon;
	time_t secs;

	ymon = t->tm_mon / 12;
	mon = t->tm_mon - ymon * 12;
	if (mon < 0)
		mon += 12, --ymon;
	if (ymon < 0 && t->tm_year < INT_MIN - ymon
		|| 0 < ymon && INT_MAX - ymon < t->tm_year)
		return ((time_t)(-1));
	year = t->tm_year + ymon;
#if 0
        /* Plauger variant */
	dsecs = 86400.0 * (_Daysto(year, mon) - 1)
		+ 31536000.0 * year + 86400.0 * t->tm_mday;
	dsecs += 3600.0 * t->tm_hour + 60.0 * t->tm_min
		+ (double)t->tm_sec;
	if (dsecs < 0.0)
		return ((time_t)(-1));
	secs = (time_t)(dsecs - (double)_TBIAS);

/*	allow wraparound times for now
	if (dsecs != (double)secs)
 *		return ((time_t)(-1));
 */
#else
        /* IAR variant. we can't use plauger due to
           double (32-bits) have insufficient precision. */

        /* Calculate number of days. */
        cdays = _Daysto(year, mon) - 1;
        cdays += 365L * year;
        cdays += t->tm_mday;

        /* Calculate number of seconds. */
        cdays += t->tm_hour / 24;
        csecs = 3600L * (t->tm_hour % 24);
        cdays += t->tm_min / (24 * 60);
        csecs += 60L * (t->tm_min % (24 * 60));
        cdays += t->tm_sec / 86400L;
        csecs += t->tm_sec % 86400L;

        /* Change from 1900 into 1970 representation. */
        cdays -= _TBIAS_DAYS;

        /* Add them together to get seconds since 1970. */
        secs = cdays * 86400L + csecs;
#endif
	_Ttotm(t, secs, t->tm_isdst);
	if (0 < t->tm_isdst)
		secs -= 3600;
	return (secs - _Tzoff());
	}
_STD_END

/*
 * Copyright (c) 1992-2002 by P.J. Plauger.  ALL RIGHTS RESERVED.
 * Consult your license regarding permissions and restrictions.
V3.12:0576 */
