/* _Assert function */
/* Copyright (C) 2003 IAR Systems.  All rights reserved. */

#include <assert.h>
#include <signal.h>
#include <stdlib.h>

_STD_BEGIN

/*
 * The idea of the _EmptyStepPoint is that the debugger, after
 * returning from an assertion and the user wants to continue
 * debugging, should highlight the "assert" macro.  (This is called
 * right after _Assert inside the macro.)
 */

void _EmptyStepPoint(void)
{
}

void _Assert(const char * file, const char * line,
             const char * func, const char * mess)
{	/* print assertion message and abort */

  /* When in debug mode, _ReportAssert will trigger the debugger to
   * inform the user and propts for further actions. */

  if (_ReportAssert(file, line, func, mess))
  {
    /* The user hit the "ignore" or "debug" button. */
    return;
  }

  abort();
}
_STD_END

/*
 * Copyright (c) 1992-2002 by P.J. Plauger.  ALL RIGHTS RESERVED.
 * Consult your license regarding permissions and restrictions.
V3.12:0576 */
