/* _Fopen function */
#include <assert.h>
#include "xstdio.h"
#include <yfuns.h>

#if _DLIB_FILE_DESCRIPTOR

_STD_BEGIN

#if (_MOPENR | _MOPENW) != 0x03
#error "BAD ASSUMPTION ABOUT _MOPENR | _MOPENW"
#endif

#pragma required = __cstart_closeall
_FD_TYPE _Fopen(const char *path, unsigned int smode,
                const char *mods)
	{	/* open a file */
	unsigned int acc;
	static const unsigned int rwacc[] =
		{0, _LLIO_RDONLY, _LLIO_WRONLY, _LLIO_RDWR};

	acc = rwacc[smode & 0x03];
	if (smode & _MOPENA)
		acc |= _LLIO_APPEND;
	if (smode & _MTRUNC)
		acc |= _LLIO_TRUNC;
	if (smode & _MCREAT)
		acc |= _LLIO_CREAT;
	if (smode & _MBIN)
		acc |= _LLIO_BINARY;
	else
	 	acc |= _LLIO_TEXT;
	return (__open(path, acc));
	}
_STD_END

#endif /* _DLIB_FILE_DESCRIPTOR */

/*
 * Copyright (c) 1992-2002 by P.J. Plauger.  ALL RIGHTS RESERVED.
 * Consult your license regarding permissions and restrictions.
V3.12:0576 */
