/* _Fwprep function */
#include <stdlib.h>
#include "xstdio.h"
#include "yfuns.h"

#if _DLIB_FILE_DESCRIPTOR

_STD_BEGIN

#pragma required = __cstart_closeall
int _Fwprep(FILE *str)
	{	/* prepare stream for writing */
	if (str->_Next < str->_Wend)
		return (0);
	else if ((str->_Mode & (_MOPENW | _MREAD | _MWIDE)) != _MOPENW)
		{	/* can't write after read */
		str->_Mode |= str->_Mode & _MWIDE
			? _MERR : _MERR | _MBYTE;
		return (-1);
		}
	else if ((str->_Mode & (_MWRITE | _MBYTE)) != (_MWRITE | _MBYTE))
		;	/* haven't been writing */
	else if (str->_Next < str->_Bend)
		;	/* open up rest of existing buffer */
	else if (fflush(str))
		return (-1);	/* failed to flush full buffer */
	if ((str->_Mode & (_MNBF | _MLBF)) != 0
		|| str->_Buf != &str->_Cbuf)
		;	/* no need to buy a buffer */
	else if ((str->_Buf = (unsigned char *)malloc(BUFSIZ)) == 0)
		{	/* use 1-char _Cbuf */
		str->_Buf = &str->_Cbuf;
		str->_Next = str->_Buf;
		str->_Bend = str->_Buf + 1;
		}
	else
		{	/* use allocated buffer */
		str->_Mode |= _MALBUF;
		str->_Next = str->_Buf;
		str->_Bend = str->_Buf + BUFSIZ;
		str->_WRend = str->_Buf;
		str->_WWend = str->_Buf;
		}
	str->_Rend = str->_Buf;
	str->_Wend = str->_Bend;
	str->_Mode |= _MWRITE | _MBYTE;
	return (0);
	}
_STD_END

#endif /* _DLIB_FILE_DESCRIPTOR */

/*
 * Copyright (c) 1992-2002 by P.J. Plauger.  ALL RIGHTS RESERVED.
 * Consult your license regarding permissions and restrictions.
V3.12:0576 */
