/* _Genld function */
#include <yvals.h>
#if _DLIB_PRINTF_SPECIFIER_FLOAT

#include <locale.h>
#include <stdlib.h>
#include <string.h>

#include <xstdio.h>
#include <xlocale.h>
_STD_BEGIN

void _Genld(_Pft *px, char code, char *p, short nsig,
            short xexp)
{       /* generate long double text */
  const char point = _LOCALE_DECIMAL_POINT;
#if _DLIB_PRINTF_WIDTH_AND_PRECISION
#if 1
    int PREC = px->prec;
#else
#define PREC px->prec
#endif
#else
    int prec = 0;
#define PREC prec
#endif /* _DLIB_PRINTF_WIDTH_AND_PRECISION */

  if (nsig <= 0)
    nsig = 1, p = "0";
  if (_LC(code) == 'f' || _LC(code) == 'g'
      && -4 <= xexp && xexp < PREC)
  {       /* 'f' format */
    ++xexp; /* change to leading digit count */
    if (_LC(code) != 'f')
    {       /* fixup for 'g' */
#if _DLIB_PRINTF_FLAGS
      if (!(px->flags & _FNO) && nsig < PREC)
#else
      if (nsig < PREC)
#endif
        PREC = nsig;
      if ((PREC -= xexp) < 0)
        PREC = 0;
    }
    if (xexp <= 0)
    {       /* digits only to right of point */
      px->s[px->n1++] = '0';
#if _DLIB_PRINTF_FLAGS
      if (0 < PREC || px->flags & _FNO)
#else
      if (0 < PREC)
#endif
        px->s[px->n1++] = point;
      if (PREC < -xexp)
        xexp = -PREC;
      px->nz1 = -xexp;
      PREC += xexp;
      if (PREC < nsig)
        nsig = PREC;
      memcpy(&px->s[px->n1], p, px->n2 = nsig);
      px->nz2 = PREC - nsig;
    }
    else if (nsig < xexp)
    {       /* zeros before point */
      memcpy(&px->s[px->n1], p, nsig);
      px->n1 += nsig;
      px->nz1 = xexp - nsig;
#if _DLIB_PRINTF_FLAGS
      if (0 < PREC || px->flags & _FNO)
#else
      if (0 < PREC)
#endif
        px->s[px->n1] = point, ++px->n2;
      px->nz2 = PREC;
    }
    else
    {       /* enough digits before point */
      memcpy(&px->s[px->n1], p, xexp);
      px->n1 += xexp;
      nsig -= xexp;
#if _DLIB_PRINTF_FLAGS
      if (0 < PREC || px->flags & _FNO)
#else
      if (0 < PREC)
#endif
        px->s[px->n1++] = point;
      if (PREC < nsig)
        nsig = PREC;
      memcpy(&px->s[px->n1], p + xexp, nsig);
      px->n1 += nsig;
      px->nz1 = PREC - nsig;
    }
  }
  else
  {       /* 'a' or 'e' format */
    if (_LC(code) == 'g')
    {       /* fixup for 'g' */
#if _DLIB_PRINTF_FLAGS
      if (nsig < PREC && !(px->flags & _FNO))
#else
      if (nsig < PREC)
#endif
        PREC = nsig;
      if (--PREC < 0)
        PREC = 0;
      code = code == 'g' ? 'e' : 'E';
    }
#if _DLIB_PRINTF_SPECIFIER_A
    else if (code == 'a')
      code = 'p';
    else if (code == 'A')
      code = 'P';
#endif
    px->s[px->n1++] = *p++;
#if _DLIB_PRINTF_FLAGS
    if (0 < PREC || px->flags & _FNO)
#else
    if (0 < PREC)
#endif
      px->s[px->n1++] = point;
    if (0 < PREC)
    {       /* put fraction digits */
      if (PREC < --nsig)
        nsig = PREC;
      memcpy(&px->s[px->n1], p, nsig);
      px->n1 += nsig;
      px->nz1 = PREC - nsig;
    }
    p = &px->s[px->n1];     /* put exponent */
    *p++ = code;
    if (0 <= xexp)
      *p++ = '+';
    else
    {       /* negative exponent */
      *p++ = '-';
      xexp = -xexp;
    }
    {      /* put decimal exponent */
      char buf[10];
      int n;

      for (n = 0; 0 < xexp; ++n)
      {       /* pick off least-significant digit */
        div_t qr = div(xexp, 10);
        buf[n] = qr.rem;
        xexp = qr.quot;
      }
      if (n < 2 && (_LC(code) == 'e'))
        *p++ = '0';     /* at least two digits after 'e' or 'E' */
      if (n == 0)
        *p++ = '0';     /* at least one digit */
      for (; 0 < n; )
        *p++ = buf[--n] + '0';  /* deliver significant digits */
    }
    px->n2 = p - &px->s[px->n1];
  }
#if _DLIB_PRINTF_FLAGS
  if ((px->flags & (_FMI|_FZE)) == _FZE)
  {       /* pad with leading zeros */
    int n = px->n0 + px->n1 + px->nz1 + px->n2 + px->nz2;

#if _DLIB_PRINTF_WIDTH_AND_PRECISION
    if (n < px->width)
      px->nz0 = px->width - n;
#else
    if (n < 0)
      px->nz0 = 0 - n;
#endif /* _DLIB_PRINTF_WIDTH_AND_PRECISION */
  }
#endif /* _DLIB_PRINTF_FLAGS */
}
_STD_END

#endif /* _DLIB_PRINTF_SPECIFIER_FLOAT */
/*
 * Copyright (c) 1992-2002 by P.J. Plauger.  ALL RIGHTS RESERVED.
 * Consult your license regarding permissions and restrictions.
 V3.12:0576 */
