/* _Litob function */
#include <string.h>
#include "xmath.h"
#include "xstdio.h"
_STD_BEGIN

static char x2dig(char c, char code)
{
  c += '0';
  if (c > '9')
    c += (code - 'x') + 'a' - '9' - 1;

  return c;
}

void _Litob(_Pft *px, char code)
{       /* convert unsigned long to text */
  char *pac = px->ac;
  int base = code == 'o' ? 8 : _LC(code) != 'x' ? 10 : 16;
  int i = _PRINTF_BUFFERT_SIZE;
  _PrintfSignedIntType li = px->v.li;
  _PrintfUnsignedIntType ulval = li;

  if ((code == 'd' || code == 'i') && li < 0)
    ulval = -ulval; /* safe against overflow */

#if _DLIB_PRINTF_WIDTH_AND_PRECISION
  if (ulval == 0 && px->prec == 0)
  {
    /* Do nothing */
  }
  else
#endif
  {
    do
    {       /* convert digits */
      pac[--i] = x2dig(ulval % base, code);
      ulval = ulval / (_PrintfUnsignedIntType)base;
    }
    while (0 < ulval && px->s < (pac + i));
  }

#if _DLIB_PRINTF_FLAGS
  if (base == 8 && px->flags & _FNO && pac[i] != '0')
    pac[--i] = '0';
#endif
  px->n1 = _PRINTF_BUFFERT_SIZE - i;
  px->s = &pac[i];

#if _DLIB_PRINTF_WIDTH_AND_PRECISION
#if _DLIB_PRINTF_FLAGS
  if (px->n1 < px->prec)
    px->nz0 = px->prec - px->n1, px->flags &= ~_FZE;
  else if (px->prec < 0 && (px->flags & (_FMI|_FZE)) == _FZE
           && 0 < (i = px->width - px->n0 - px->nz0 - px->n1))
    px->nz0 = i;
#else /* _DLIB_PRINTF_FLAGS */
  if (px->n1 < px->prec)
    px->nz0 = px->prec - px->n1;
#endif /* _DLIB_PRINTF_FLAGS */
#endif /* _DLIB_PRINTF_WIDTH_AND_PRECISION */
}
_STD_END

/*
 * Copyright (c) 1992-2002 by P.J. Plauger.  ALL RIGHTS RESERVED.
 * Consult your license regarding permissions and restrictions.
 V3.12:0576 */
