/* _Stopfx function */
#include <ctype.h>
#include "xmath.h"
_STD_BEGIN

int _Stopfx(const char **ps, char **endptr)
	{	/* parse prefix of floating-point field */
	const char *s = *ps;
	int code = 0;

	for (; isspace(*s); ++s)
		;
	if (*s == '-')
		code = FL_NEG, ++s;
	else if (*s == '+')
		++s;
	if (_LC(*s) == 'n')
		{	/* parse "nan" or fail */
		if ((_LC(*++s) != 'a') || (_LC(*++s) != 'n'))
			code = FL_ERR;
		else if (*s != '(')
			code = FL_NAN, ++s;
		else
			{	/* parse (n-char-sequence) */
			for (; isalnum(*++s) || *s == '_'; )
				;
			if (*s != ')')
				code = FL_ERR;
			else
				code = FL_NAN, ++s;
			}
		if (endptr != 0)
			*endptr = (char *)s;
		}
	else if (_LC(*s) == 'i')
		{	/* parse "inf" or fail */
		if ((_LC(*++s) != 'n') || (_LC(*++s) != 'f'))
			code = FL_ERR;
		else if (_LC(*++s) != 'i')
			code |= FL_INF;
		else
			{	/* parse rest of  "infinity" */
			if (   _LC(*++s) != 'n'
                            || _LC(*++s) != 'i'
                            || _LC(*++s) != 't'
                            || _LC(*++s) != 'y')
				code = FL_ERR;
			else
				code |= FL_INF, ++s;
			}
		if (endptr != 0)
			*endptr = (char *)s;
		}
#if _DLIB_STRTOD_HEX_FLOAT
	else if (   *s == '0'
                 && _LC(*(s+1)) == 'x')
                {
                        s += 2;
               		code |= FL_HEX;
                }
#endif
        else
                {
	        	code |= FL_DEC;
                }
	*ps = s;
	return (code);
	}
_STD_END

/*
 * Copyright (c) 1992-2002 by P.J. Plauger.  ALL RIGHTS RESERVED.
 * Consult your license regarding permissions and restrictions.
V3.12:0576 */
