/* Taken from xdscale.c, then exchanged F against T in all macros and
   further templified it. */

short FNAME(Dscale)(FTYPE *px, long lexp)
{       /* scale *px by 2^xexp with checking */
  unsigned short *ps = (unsigned short *)px;
  short xchar = (short)((ps[_X0] & _XMASK) >> _XOFF);

  if (xchar == _XMAX)
    return (   (ps[_X0] & _XFRAC) != 0
#if !__NAN_HAS_HIGH_MANTISSA_BIT_SET__
            || ps[_X1] != 0 || ps[_X2] != 0 || ps[_X3] != 0
#endif
             ? _NANCODE : _INFCODE);
  else if (xchar == 0 && 0 < (xchar = FNAME(Dnorm)(ps)))
    return (0);
  lexp += xchar;
  if (_XMAX <= lexp)
  {       /* overflow, return +/-INF */
    *px = ps[_X0] & _XSIGN ? -_FCONST(Inf) : _FCONST(Inf);
    return (_INFCODE);
  }
  else if (0 < lexp)
  {       /* finite result, repack */
    ps[_X0] = ps[_X0] & ~_XMASK | (short)lexp << _XOFF;
    return (_FINITE);
  }
  else
  {       /* denormalized, scale */
#if !__SUBNORMAL_FLOATING_POINTS__
    ps[_X0] &= _XSIGN;
    ps[_X1] = 0;
    ps[_X2] = 0;
    ps[_X3] = 0;
    return (0);
#else
    unsigned short sign = ps[_X0] & _XSIGN;

    ps[_X0] = (unsigned short)(1 << _XOFF
                               | ps[_X0] & _XFRAC);
    if (--lexp < -(48+_XOFF))
    {       /* underflow, return +/-0 */
      ps[_X0] = sign, ps[_X1] = 0;
      ps[_X2] = 0, ps[_X3] = 0;
      return (0);
    }
    else
    {       /* nonzero, align fraction */
      short xexp;
      for (xexp = (short)lexp; xexp <= -16; xexp += 16)
      {       /* scale by words */
        ps[_X3] = ps[_X2], ps[_X2] = ps[_X1];
        ps[_X1] = ps[_X0], ps[_X0] = 0;
      }
      if ((xexp = -xexp) != 0)
      {       /* scale by bits */
        ps[_X3] = ps[_X3] >> xexp
          | ps[_X2] << (16 - xexp);
        ps[_X2] = ps[_X2] >> xexp
          | ps[_X1] << (16 - xexp);
        ps[_X1] = ps[_X1] >> xexp
          | ps[_X0] << (16 - xexp);
        ps[_X0] >>= xexp;
      }
      ps[_X0] |= sign;
      return (_FINITE);
    }
#endif /* __SUBNORMAL_FLOATING_POINTS__ */
  }
}
