/* Taken from xdunscal.c, then exchanged F against T in all macros and 
   further templified it. */

short FNAME(Dunscale)(short *pex, FTYPE *px)
{       /* separate *px to 1/2 <= |frac| < 1 and 2^*pex */
  unsigned short *ps = (unsigned short *)px;
  short xchar = (ps[_X0] & _XMASK) >> _XOFF;

  if (xchar == _XMAX)
  {       /* NaN or INF */
    *pex = 0;
    return (   (ps[_X0] & _XFRAC) != 0
#if !__NAN_HAS_HIGH_MANTISSA_BIT_SET__
            || ps[_X1] != 0 || ps[_X2] != 0 || ps[_X3] != 0
#endif
             ? _NANCODE : _INFCODE);
  }
  else if (0 < xchar || (xchar = FNAME(Dnorm)(ps)) <= 0)
  {       /* finite, reduce to [1/2, 1) */
    ps[_X0] = ps[_X0] & ~_XMASK | _XBIAS << _XOFF;
    *pex = xchar - _XBIAS;
    return (_FINITE);
  }
  else
  {       /* zero */
    *pex = 0;
    return (0);
  }
}
